diff -r f2000f2db021 trytond/modules/stock_split/tests/test_stock_split.py
--- a/trytond/modules/stock_split/tests/test_stock_split.py	Mon Sep 10 15:28:47 2012 +0200
+++ b/trytond/modules/stock_split/tests/test_stock_split.py	Mon Sep 24 20:36:43 2012 +0200
@@ -49,79 +49,72 @@
         Test split.
         '''
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
-            unit_id, = self.uom.search([('name', '=', 'Unit')])
-            unit = self.uom.browse(unit_id)
-            product_id = self.product.create({
+            unit, = self.uom.search([('name', '=', 'Unit')])
+            product = self.product.create({
                     'name': 'Test Split',
                     'type': 'goods',
                     'cost_price_method': 'fixed',
-                    'default_uom': unit_id,
+                    'default_uom': unit.id,
                     'list_price': Decimal(0),
                     'cost_price': Decimal(0),
                     })
-            input_id, = self.location.search([('code', '=', 'IN')])
-            storage_id, = self.location.search([('code', '=', 'STO')])
-            company_id, = self.company.search([('name', '=', 'B2CK')])
-            self.user.write(USER, {
-                'main_company': company_id,
-                'company': company_id,
-                })
+            input_, = self.location.search([('code', '=', 'IN')])
+            storage, = self.location.search([('code', '=', 'STO')])
+            company, = self.company.search([('name', '=', 'B2CK')])
+            self.user.write([self.user(USER)], {
+                    'main_company': company.id,
+                    'company': company.id,
+                    })
 
             def create_move(quantity):
-                move_id = self.move.create({
-                        'product': product_id,
-                        'uom': unit_id,
+                move = self.move.create({
+                        'product': product.id,
+                        'uom': unit.id,
                         'quantity': quantity,
-                        'from_location': input_id,
-                        'to_location': storage_id,
-                        'company': company_id,
+                        'from_location': input_.id,
+                        'to_location': storage.id,
+                        'company': company.id,
                         })
-                return self.move.browse(move_id)
+                return move
 
             move = create_move(10)
-            move_ids = self.move.split(move, 5, unit)
-            self.assertEqual(len(move_ids), 2)
-            self.assertEqual([m.quantity for m in self.move.browse(move_ids)],
-                [5, 5])
+            moves = move.split(5, unit)
+            self.assertEqual(len(moves), 2)
+            self.assertEqual([m.quantity for m in moves], [5, 5])
 
             move = create_move(13)
-            move_ids = self.move.split(move, 5, unit)
-            self.assertEqual(len(move_ids), 3)
-            self.assertEqual([m.quantity for m in self.move.browse(move_ids)],
-                [5, 5, 3])
+            moves = move.split(5, unit)
+            self.assertEqual(len(moves), 3)
+            self.assertEqual([m.quantity for m in moves], [5, 5, 3])
 
             move = create_move(7)
-            move_ids = self.move.split(move, 8, unit)
-            self.assertEqual(move_ids, [move.id])
+            moves = move.split(8, unit)
+            self.assertEqual(moves, [move])
             self.assertEqual(move.quantity, 7)
 
             move = create_move(20)
-            move_ids = self.move.split(move, 5, unit, count=2)
-            self.assertEqual(len(move_ids), 3)
-            self.assertEqual([m.quantity for m in self.move.browse(move_ids)],
-                [5, 5, 10])
+            moves = move.split(5, unit, count=2)
+            self.assertEqual(len(moves), 3)
+            self.assertEqual([m.quantity for m in moves], [5, 5, 10])
 
             move = create_move(20)
-            move_ids = self.move.split(move, 5, unit, count=4)
-            self.assertEqual(len(move_ids), 4)
-            self.assertEqual([m.quantity for m in self.move.browse(move_ids)],
-                [5, 5, 5, 5])
+            moves = move.split(5, unit, count=4)
+            self.assertEqual(len(moves), 4)
+            self.assertEqual([m.quantity for m in moves], [5, 5, 5, 5])
 
             move = create_move(10)
-            move_ids = self.move.split(move, 5, unit, count=3)
-            self.assertEqual(len(move_ids), 2)
-            self.assertEqual([m.quantity for m in self.move.browse(move_ids)],
-                [5, 5])
+            moves = move.split(5, unit, count=3)
+            self.assertEqual(len(moves), 2)
+            self.assertEqual([m.quantity for m in moves], [5, 5])
 
             move = create_move(10)
-            self.move.write(move.id, {
+            self.move.write([move], {
                     'state': 'assigned',
                     })
-            move_ids = self.move.split(move, 5, unit)
-            self.assertEqual(len(move_ids), 2)
-            self.assertEqual([m.quantity for m in self.move.browse(move_ids)],
-                [5, 5])
-            self.assertEqual([m.state for m in self.move.browse(move_ids)],
+            moves = move.split(5, unit)
+            self.assertEqual(len(moves), 2)
+            self.assertEqual([m.quantity for m in moves], [5, 5])
+            self.assertEqual([m.state for m in moves],
                 ['assigned', 'assigned'])
 
 
diff -r bd39479d70b4 trytond/modules/stock_supply/__init__.py
--- a/trytond/modules/stock_supply/__init__.py	Thu Sep 20 16:16:56 2012 +0200
+++ b/trytond/modules/stock_supply/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,6 +1,24 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
+
+from trytond.pool import Pool
 from .order_point import *
 from .product import *
 from .purchase_request import *
 from .shipment import *
+
+
+def register():
+    Pool.register(
+        OrderPoint,
+        Product,
+        PurchaseRequest,
+        CreatePurchaseRequestStart,
+        CreatePurchaseAskTerm,
+        CreatePurchaseAskParty,
+        ShipmentInternal,
+        module='stock_supply', type_='model')
+    Pool.register(
+        CreatePurchaseRequest,
+        CreatePurchase,
+        module='stock_supply', type_='wizard')
diff -r bd39479d70b4 trytond/modules/stock_supply/order_point.py
--- a/trytond/modules/stock_supply/order_point.py	Thu Sep 20 16:16:56 2012 +0200
+++ b/trytond/modules/stock_supply/order_point.py	Mon Sep 24 20:36:43 2012 +0200
@@ -3,19 +3,19 @@
 from trytond.model import ModelView, ModelSQL, fields
 from trytond.pyson import If, Equal, Eval, Not, In, Get
 from trytond.transaction import Transaction
-from trytond.pool import Pool
 from trytond.backend import TableHandler
 
+__all__ = ['OrderPoint']
+
 
 class OrderPoint(ModelSQL, ModelView):
     """
-    Order Point: Provide a way to define a supply policy for each
+    Order Point
+    Provide a way to define a supply policy for each
     product on each locations. Order points on warehouse are
     considered by the supply scheduler to generate purchase requests.
     """
-    _name = 'stock.order_point'
-    _description = "Order Point"
-
+    __name__ = 'stock.order_point'
     product = fields.Many2One('product.product', 'Product', required=True,
         select=True,
         domain=[
@@ -69,18 +69,19 @@
     unit_digits = fields.Function(fields.Integer('Unit Digits'),
             'get_unit_digits')
 
-    def __init__(self):
-        super(OrderPoint, self).__init__()
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(OrderPoint, cls).__setup__()
+        cls._constraints += [
             ('check_concurrent_internal', 'concurrent_internal_op'),
             ('check_uniqueness', 'unique_op'),
             ]
-        self._sql_constraints += [
+        cls._sql_constraints += [
             ('check_max_qty_greater_min_qty',
                 'CHECK(max_quantity >= min_quantity)',
                 'Maximal quantity must be bigger than Minimal quantity'),
             ]
-        self._error_messages.update({
+        cls._error_messages.update({
                 'unique_op': 'Only one order point is allowed '\
                     'for each product-location pair.',
                 'concurrent_internal_op': 'You can not define ' \
@@ -88,68 +89,63 @@
                     'with opposite locations.',
                 })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 2.2
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.drop_constraint('check_min_max_quantity')
 
-        super(OrderPoint, self).init(module_name)
+        super(OrderPoint, cls).__register__(module_name)
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return "purchase"
 
-    def on_change_product(self, vals):
-        product_obj = Pool().get('product.product')
+    def on_change_product(self):
         res = {
             'unit': None,
             'unit.rec_name': '',
             'unit_digits': 2,
-        }
-        if vals.get('product'):
-            product = product_obj.browse(vals['product'])
-            res['unit'] = product.default_uom.id
-            res['unit.rec_name'] = product.default_uom.rec_name
-            res['unit_digits'] = product.default_uom.digits
+            }
+        if self.product:
+            res['unit'] = self.product.default_uom.id
+            res['unit.rec_name'] = self.product.default_uom.rec_name
+            res['unit_digits'] = self.product.default_uom.digits
         return res
 
-    def get_unit(self, ids, name):
-        res = {}
-        for order in self.browse(ids):
-            res[order.id] = order.product.default_uom.id
-        return res
+    def get_unit(self, name):
+        return self.product.default_uom.id
 
-    def get_unit_digits(self, ids, name):
-        res = {}
-        for order in self.browse(ids):
-            res[order.id] = order.product.default_uom.digits
-        return res
+    def get_unit_digits(self, name):
+        return self.product.default_uom.digits
 
-    def check_concurrent_internal(self, ids):
+    @classmethod
+    def check_concurrent_internal(cls, orders):
         """
         Ensure that there is no 'concurrent' internal order
         points. I.E. no two order point with opposite location for the
         same product and same company.
         """
-        internal_ids = self.search([
-            ('id', 'in', ids),
-            ('type', '=', 'internal'),
-            ])
-        if not internal_ids:
+        internals = cls.search([
+                ('id', 'in', [o.id for o in orders]),
+                ('type', '=', 'internal'),
+                ])
+        if not internals:
             return True
 
         query = ['OR']
-        for op in self.browse(internal_ids):
+        for op in internals:
             arg = ['AND',
                    ('provisioning_location', '=', op.storage_location.id),
                    ('storage_location', '=', op.provisioning_location.id),
                    ('company', '=', op.company.id),
                    ('type', '=', 'internal')]
             query.append(arg)
-        ids = self.search(query)
-        return not bool(ids)
+        return not bool(cls.search(query))
 
-    def _type2field(self, type=None):
+    @staticmethod
+    def _type2field(type=None):
         t2f = {
             'purchase': 'warehouse_location',
             'internal': 'storage_location',
@@ -159,36 +155,30 @@
         else:
             return t2f[type]
 
-    def check_uniqueness(self, ids):
+    @classmethod
+    def check_uniqueness(cls, orders):
         """
         Ensure uniqueness of order points. I.E that there is no several
         order point for the same location, the same product and the
         same company.
         """
         query = ['OR']
-        for op in self.browse(ids):
-            field = self._type2field(op.type)
+        for op in orders:
+            field = cls._type2field(op.type)
             arg = ['AND',
                 ('product', '=', op.product.id),
-                (field, '=', op[field].id),
+                (field, '=', getattr(op, field).id),
                 ('id', '!=', op.id),
                 ('company', '=', op.company.id),
                 ]
             query.append(arg)
-        ids = self.search(query)
-        return not bool(ids)
+        return not bool(cls.search(query))
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        res = {}
-        for op in self.browse(ids):
-            res[op.id] = "%s@%s" % (op.product.name, op.location.name)
-        return res
+    def get_rec_name(self, name):
+        return "%s@%s" % (self.product.name, self.location.name)
 
-    def search_rec_name(self, name, clause):
+    @classmethod
+    def search_rec_name(cls, name, clause):
         res = []
         names = clause[2].split('@', 1)
         res.append(('product.template.name', clause[1], names[0]))
@@ -196,27 +186,22 @@
             res.append(('location', clause[1], names[1]))
         return res
 
-    def get_location(self, ids, name):
-        res = {}
-        for op in self.browse(ids):
-            if op.type == 'purchase':
-                res[op.id] = op.warehouse_location.id
-            elif op.type == 'internal':
-                res[op.id] = op.storage_location.id
-            else:
-                res[op.id] = None
-        return res
+    def get_location(self, name):
+        if self.type == 'purchase':
+            return self.warehouse_location.id
+        elif self.type == 'internal':
+            return self.storage_location.id
 
-    def search_location(self, name, domain=None):
+    @classmethod
+    def search_location(cls, name, domain=None):
         ids = []
-        for type, field in self._type2field().iteritems():
+        for type, field in cls._type2field().iteritems():
             args = [('type', '=', type)]
             for _, operator, operand in domain:
                 args.append((field, operator, operand))
-            ids.extend(self.search(args))
+            ids.extend([o.id for o in cls.search(args)])
         return [('id', 'in', ids)]
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
-
-OrderPoint()
diff -r bd39479d70b4 trytond/modules/stock_supply/product.py
--- a/trytond/modules/stock_supply/product.py	Thu Sep 20 16:16:56 2012 +0200
+++ b/trytond/modules/stock_supply/product.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,12 +1,13 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL, fields
+from trytond.model import fields
+from trytond.pool import PoolMeta
 
+__all__ = ['Product']
+__metaclass__ = PoolMeta
 
-class Product(ModelSQL, ModelView):
-    _name = "product.product"
 
+class Product:
+    __name__ = "product.product"
     order_points = fields.One2Many(
         'stock.order_point', 'product', 'Order Points')
-
-Product()
